﻿using Android.App;
using Android.Widget;
using Android.OS;
using ThinkGeo.MapSuite.AndroidEdition;
using ThinkGeo.MapSuite.Core;
using Android.Graphics;

namespace LimitScale
{
    [Activity(Label = "LimitScale", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        TextView outputScale;
        MapView map;
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            SetContentView(Resource.Layout.Main);

            outputScale = FindViewById<TextView>(Resource.Id.scale);

            map = FindViewById<MapView>(Resource.Id.map);
            map.SetBackgroundColor(Color.White);
            map.MapUnit = GeographyUnit.Meter;
            map.CurrentExtent = new RectangleShape(-20037508.352, 20037508.352, 20037508.352, -20037508.352);
            map.MinimumScale = 1;

            OpenStreetMapOverlay osmOverlay = new OpenStreetMapOverlay();
            map.Overlays.Add("OSM", osmOverlay);

            map.CurrentScaleChanging += CurrentScaleChanging; ;
        }

        private void CurrentScaleChanging(object sender, CurrentScaleChangingMapViewEventArgs e)
        {
            double scale = ((MapView)sender).CurrentScale;
            OpenStreetMapOverlay osmOverlay = (OpenStreetMapOverlay)map.Overlays["OSM"];
            outputScale.Text = "Map Current Scale : " + scale.ToString();

            if (scale < map.ZoomLevelSet.ZoomLevel20.Scale)
                osmOverlay.IsVisible = false;
            else
                osmOverlay.IsVisible = true;
        }
    }
}

